/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer: Patrick Boenzli
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_OBJECT_MANAGER

#include "object_manager.h"
#include "garbage_collector.h"
#include "list.h"

#include "debug.h"

using namespace std;

/**
 *  standard constructor
*/
ObjectManager::ObjectManager ()
{
  this->setClassID(CL_OBJECT_MANAGER, "ObjectManager");
  this->setName("ObjectManager");

}


/**
 *  the singleton reference to this class
*/
ObjectManager* ObjectManager::singletonRef = NULL;

/**
 *  standard deconstructor
*/
ObjectManager::~ObjectManager ()
{
  ObjectManager::singletonRef = NULL;
}

/**
 *  outputs some simple debug information about the ObjectManage
*/
void ObjectManager::debug() const
{
  PRINT(0)("\n==========================| ObjectManager::debug() |===\n");
/* PRINT(0)("=  Number of registerable classes: %i\n", CL_NUMBER );
 PRINT(0)("=  Currently cached objects: \n");
 for(int i = 0; i < CL_NUMBER; ++i)
   {
      if( this->managedObjectList[i] != NULL)
        PRINT(0)("=   o Class Nr. %i has cached %i object(s)\n", i, this->managedObjectList[i]->getSize());
      else
        PRINT(0)("=   o Class Nr. %i has cached 0 object(s)\n", i);
    }*/
  PRINT(0)("=======================================================\n");
}


